'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createState;

var _getDependencies = require('./getDependencies');

var _getDependencies2 = _interopRequireDefault(_getDependencies);

var _getKeyInjector = require('./getKeyInjector');

var _getKeyInjector2 = _interopRequireDefault(_getKeyInjector);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createState(shape, prevState) {

  var stateContainer = {};

  if (prevState) Object.keys(prevState).filter(function (key) {
    return !shape.hasOwnProperty(key);
  }).forEach((0, _getKeyInjector2.default)(stateContainer, prevState, shape));else Object.keys(shape).filter(function (key) {
    return typeof shape[key] === 'function';
  }).forEach(function (key) {
    shape[key].updatedBy = (0, _getDependencies2.default)(shape, key);
  });

  Object.keys(shape).forEach((0, _getKeyInjector2.default)(stateContainer, shape));

  Object.defineProperty(stateContainer, 'copy', {
    enumerable: false,
    writable: false,
    value: function value() {
      var newValues = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      return createState(newValues, stateContainer);
    }
  });

  return stateContainer;
}