'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getKeyInjector;

var _lodash = require('lodash.memoize');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getKeyInjector(stateContainer, reference, newValues) {
  return function (key) {
    if (typeof reference[key] !== 'function') {

      stateContainer[key] = reference[key];
    } else {

      var getterKey = key.replace(/@@__fn_/g, '');
      var functionKey = '@@__fn_' + getterKey;

      var shouldReuseCache = newValues && reference[functionKey].updatedBy && reference[functionKey].updatedBy.every(function (key) {
        return !newValues.hasOwnProperty(key);
      });

      var getter = (0, _lodash2.default)(function () {
        if (shouldReuseCache) return reference[getterKey];else {
          var params = reference[key].paramNames.map(function (param) {
            return stateContainer[param];
          });
          return reference[key].apply(stateContainer, params);
        }
      });

      Object.defineProperty(stateContainer, functionKey, {
        enumerable: true,
        writable: false,
        value: reference[key]
      });

      Object.defineProperty(stateContainer, getterKey, {
        enumerable: false,
        get: getter
      });
    }
  };
}