'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = function (initialState) {
  return function (WrappedComponent) {
    var componentWithState = function (_Component) {
      _inherits(componentWithState, _Component);

      function componentWithState(props) {
        _classCallCheck(this, componentWithState);

        var _this = _possibleConstructorReturn(this, (componentWithState.__proto__ || Object.getPrototypeOf(componentWithState)).call(this, props));

        _this.state = { currentState: initialState };
        _this.updateState = _this.updateState.bind(_this);
        return _this;
      }

      _createClass(componentWithState, [{
        key: 'updateState',
        value: function updateState(stateChanges) {
          this.setState({ currentState: this.state.currentState.copy(stateChanges) });
        }
      }, {
        key: 'render',
        value: function render() {
          return _react2.default.createElement(WrappedComponent, _extends({}, this.props, {
            state: this.state.currentState,
            setState: this.updateState
          }));
        }
      }]);

      return componentWithState;
    }(_react.Component);

    componentWithState.displayName = getDisplayName(WrappedComponent);

    return componentWithState;
  };
};

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function getDisplayName(wrappedComponent) {
  var wrapperName = wrappedComponent.displayName || wrappedComponent.name || 'Component';
  return 'withState(' + wrapperName + ')';
}